<!DOCTYPE html>
<html>
  <head>
    <title>OpenEBench REST API</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <style>
      body { width: 90%;
             margin-left: auto;
             margin-right: auto;
      }
      table { 
        width: 100%; 
        border-collapse: separate;
        border-spacing: 0px 12px;
      }
      td { border-width: 1px 0px 1px 0px;
           border-style: solid;
           padding: 8px;
      }
      td:first-child { width: 5%; }
      td:nth-child(2) { white-space: nowrap; } 
      td:nth-child(3) { white-space: nowrap; }     
      td:last-child { width: 80%; }

      tr td:first-child { 
        border-left-width: 1px !important; 
        border-top-left-radius: 8px;
        border-bottom-left-radius: 8px; 
      }
      tr td:last-child { 
        border-right-width: 1px !important;
        border-top-right-radius: 8px;
        border-bottom-right-radius: 8px; 
      }

      tr td:first-child:before {
        display: inline-block;
        width: 100%;
        text-align: center;
        padding: 2px 0px 2px 0px;
      }

      tr.GET td {
        border-color: #61affe;
        background-color: #eff7ff;
      }
      tr.GET td:first-child:before {
        content: "GET";
        color: #eff7ff;
        background-color: #61affe;
      }

      tr.HEAD td {
        border-color: #9012fe;
        background-color: #f4e7ff;
      }
      tr.HEAD td:first-child:before {
        content: "HEAD";
        color: #f4e7ff;
        background-color: #9012fe;
      }

      tr.POST td {
        border-color: #49cc90;
        background-color: #ecfaf4;
      }
      tr.POST td:first-child:before {
        content: "POST";
        color: #ecfaf4;
        background-color: #49cc90;
      }

      tr.PUT td {
        border-color: #fca130;
        background-color: #fff5ea;
      }
      tr.PUT td:first-child:before {
        content: "PUT";
        color: #fff5ea;
        background-color: #fca130;
      }

      tr.PATCH td {
        border-color: #42e5c4;
        background-color: #e7f7f4;
      }
      tr.PATCH td:first-child:before {
        content: "PATCH";
        color: #e7f7f4;
        background-color: #42e5c4;
      }

      tr.DELETE td {
        border-color: #f93e3e;
        background-color: #feebeb;
      }
      tr.DELETE td:first-child:before {
        content: "DELETE";
        color: #feebeb;
        background-color: #f93e3e;
      }
 
    </style>
  </head>
  <body>
    <h2>OpenEBench REST API</h2>
    <hr/>
    OpenEBench REST API has two endpoints: one for the production './staged' and another one for the sandbox './sandbox'.
    <table>
      <tr class="POST">
        <td></td>
        <td>/sandbox/?community_id={community_id}</td><td>Content-Type: application/json</td>
        <td>
          Submit OpenEBench data as an array of json objects.
          Objects' types and ids are taken from the '_id' and '_schema' attributes.
        </td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox</td><td>Accept: application/json</td><td>Get all authenticated user submitted data.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox/{collection}/?privileged={true | false}</td>
        <td>Accept: application/json</td>
        <td>
          List OpenEBench collection of submitted data. If privileged=true only 'privileged' objects 
          (those the user is authorized to write) are returned.
        </td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox/{collection}</td><td>Accept: text/uri-list</td><td>List all OpenEBench collection data identifiers.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox/{collection}</td><td>Accept: text/x-uri</td><td>Get the URI of the JSON Schema to validate the collection.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox/{collection}</td><td>Accept: application/schema+json</td><td>Get the JSON Schema to validate the collection.</td>
      </tr>
      <tr class="POST">
        <td></td>
        <td>/sandbox/{collection}/?community_id={community_id}</td><td>Content-Type: application/json</td>
        <td>
          Submit OpenEBench collection of data as an array of json objects.
          Objects' identifiers are taken from the object's '_id' attribute.
        </td>
      </tr>
      <tr class="HEAD">
        <td></td>
        <td>/sandbox/{collection}/{id}</td><td></td><td>Check whether the object exists in the submission.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/sandbox/{collection}/{id}</td><td></td><td>Get OpenEBench submitted data object.</td>
      </tr>
      <tr class="PUT">
        <td></td>
        <td>/sandbox/{collection}/{id}/?community_id={community_id}</td><td>Content-Type: application/json</td><td>Submit OpenEBench data object.</td>
      </tr>
      <tr class="PATCH">
        <td></td>
        <td>/sandbox/{collection}/{id}</td><td>Content-Type: application/json</td><td>Update OpenEBench data object.</td>
      </tr>
      <tr class="DELETE">
        <td></td>
        <td>/sandbox/{collection}/{id}</td><td></td><td>Remove OpenEBench object from submission.</td>
      </tr>
      <tr class="POST">
        <td></td>
        <td>/staged/?community_id={community_id}</td><td>Content-Type: application/json</td>
        <td>
          Upload OpenEBench data as an array of json objects.
          Objects' types and ids are taken from the '_id' and '_schema' attributes.
        </td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/staged/{collection}/?privileged={true | false}</td>
        <td>Accept: application/json</td>
        <td>
          List entire OpenEBench collection. If privileged=true only 'privileged' objects 
          (those the user is authorized to write) are returned.
        </td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/staged/{collection}</td><td>Accept: text/uri-list</td><td>List all OpenEBench collection data identifiers.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/staged/{collection}</td><td>Accept: text/x-uri</td><td>Get the URI of the JSON Schema to validate the collection.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/staged/{collection}</td><td>Accept: application/schema+json</td><td>Get the JSON Schema to validate the collection.</td>
      </tr>
      <tr class="POST">
        <td></td>
        <td>/staged/{collection}/?community_id={community_id}</td><td>Content-Type: application/json</td>
        <td>
          Upload OpenEBench collection of data as an array of json objects.
          Objects' identifiers are taken from the object's '_id' attribute.
        </td>
      </tr>
      <tr class="HEAD">
        <td></td>
        <td>/staged/{collection}/{id}</td><td></td><td>Check whether the object exists in the collection.</td>
      </tr>
      <tr class="GET">
        <td></td>
        <td>/staged/{collection}/{id}</td><td></td><td>Get OpenEBench data object.</td>
      </tr>
      <tr class="PUT">
        <td></td>
        <td>/staged/{collection}/{id}/?community_id={community_id}</td><td>Content-Type: application/json</td><td>Insert OpenEBench data object.</td>
      </tr>
      <tr class="PATCH">
        <td></td>
        <td>/staged/{collection}/{id}</td><td>Content-Type: application/json</td><td>Update OpenEBench data object.</td>
      </tr>
      <tr class="DELETE">
        <td></td>
        <td>/staged/{collection}/{id}</td><td></td><td>Mark OpenEBench data object as deleted.</td>
      </tr>
    </table>

  </body>
</html>
